5 ### (c) 2012 Mark Wooding
8 ###----- Licensing notice ---------------------------------------------------
10 ### This file is part of the `rsync-backup' program.
12 ### rsync-backup is free software; you can redistribute it and/or modify
13 ### it under the terms of the GNU General Public License as published by
14 ### the Free Software Foundation; either version 2 of the License, or
15 ### (at your option) any later version.
17 ### rsync-backup is distributed in the hope that it will be useful,
18 ### but WITHOUT ANY WARRANTY; without even the implied warranty of
19 ### MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
20 ### GNU General Public License for more details.
22 ### You should have received a copy of the GNU General Public License
23 ### along with rsync-backup; if not, write to the Free Software Foundation,
24 ### Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
28 thishost=$(hostname -s)
35 ###--------------------------------------------------------------------------
36 ### Utility functions.
41 ## Run rsync(1) in an appropriate manner. Configuration should ovrride
42 ## this or set $RSYNCOPTS if it wants to do something weirder. Arguments
43 ## to this function are passed on to rsync.
46 --archive --hard-links --acls --xattrs --numeric-ids --del \
51 --filter="dir-merge .rsync-backup" \
61 now=$(date +"%Y-%m-%d %H:%M:%S %z")
68 ## Run CMD, if this isn't a dry run.
71 t) echo >&2 " +++ $*" ;;
78 ## Copy lines from stdin to stdout, adding PREFIX.
80 while IFS= read -r line; do
81 printf "%s %s\n" "$prefix" "$line"
89 -stdin) stdinp=t; shift ;;
94 tag=$1 cmd=$2; shift 2
95 ## Run CMD, logging its output in a pleasing manner.
99 echo >&2 " *** RUN $tag"
100 echo >&2 " +++ $cmd $*"
106 case $stdinp in nil) exec </dev/null ;; esac
108 "$cmd" "$@" 3>&- 4>&- 5>&- 9>&-
110 copy "|" >&4; } 2>&1 |
111 copy "*" >&4; } 4>&1 |
116 *) log "FAIL $tag (rc = $rc)" ;;
125 ## Write a unified diff from OLD to NEW, to OUT.
127 set +e; diff -u "$old" "$new" >"$out"; rc=$?; set -e
128 case $rc in 1) cat "$out" ;; esac
134 ## Answer whether H is a local host.
137 "$thishost") return 0 ;;
144 ## Run CMD on the current host. If the host seems local then run the
145 ## command through a local shell; otherwise run it through ssh(1). Either
146 ## way it will be processed by a shell.
148 if localp $host; then run "@$host: $tag" sh -c "$cmd"
149 else run "@$host: $tag" ssh $userat$host "$cmd"
155 ## Like hostrun, but without the complicated logging, and targetted at a
158 if localp $h; then sh -c "$cmd"
165 ## Output (to stdout) either PATH or HOST:PATH, choosing the former if the
166 ## current host is local.
168 if localp $host; then echo $path
169 else echo $userat$host:$path
175 ## Define a hook called HOOK.
182 ## Add command CMD to the hook HOOK.
184 eval old=\$hk_$hook; new="$old $cmd"
190 ## Invoke HOOK, passing it the remaining arguments.
194 if ! $cmd "$@"; then return $?; fi
198 remove_old_logfiles () {
200 ## Remove old logfiles with names of the form BASE.DATE#N, so that there
201 ## are at most $MAXLOG of them.
203 ## Count up the logfiles.
205 for i in "$base".*; do
206 if [ ! -f "$i" ]; then continue; fi
210 ## If there are too many, go through and delete some early ones.
211 if [ $dryrun = nil ] && [ $nlog -gt $MAXLOG ]; then
212 n=$(( nlog - MAXLOG ))
213 for i in "$base".*; do
214 if [ ! -f "$i" ]; then continue; fi
217 if [ $n -eq 0 ]; then break; fi
222 ###--------------------------------------------------------------------------
223 ### Database operations.
226 host=$1 fs=$2 date=$3 vol=$4
228 if [ -f "$INDEXDB" ]; then
229 sqlite3 "$INDEXDB" <<EOF
230 INSERT INTO idx (host, fs, date, vol)
231 VALUES ('$host', '$fs', '$date', '$vol');
237 host=$1 fs=$2 date=$3
239 if [ -f "$INDEXDB" ]; then
240 sqlite3 "$INDEXDB" <<EOF
241 DELETE FROM idx WHERE
242 host = '$host' AND fs = '$fs' AND date = '$date';
247 ###--------------------------------------------------------------------------
248 ### Snapshot handling.
250 ## Snapshot protocol. Each snapshot type has a pair of functions snap_TYPE
251 ## and unsnap_TYPE. Each is given the current snapshot arguments and the
252 ## filesystem name to back up. The snap_TYPE function should create and
253 ## mount the snapshot and output an rsync(1) path to where the filesystem can
254 ## be copied; the unsnap_TYPE function should unmount and tear down the
257 ## Fake snapshot by not doing anything. Use only if you have no choice.
258 snap_live () { hostpath "$2"; }
259 unsnap_live () { :; }
261 ## Fake snapshot by remounting a live filesystem read-only. Useful if the
262 ## underlying storage isn't in LVM.
267 ## Place a marker in the filesystem so we know why it was made readonly.
268 ## (Also this serves to ensure that the filesystem was writable before.)
269 hostrun "snap-ro $mnt" "
270 echo rsync-backup >$mnt/.lock
271 mount -oremount,ro $mnt" || return $?
280 ## Check that the filesystem still has our lock marker.
281 hostrun "unsnap-ro $mnt" "
282 case \$(cat $mnt/.lock) in
284 *) echo unlocked by someone else; exit 31 ;;
286 mount -oremount,rw $mnt
287 rm $mnt/.lock" || return $?
290 ## Snapshot using LVM.
292 SNAPSIZE="-l10%ORIGIN"
297 ## Make the snapshot.
298 hostrun "snap-lvm $vg/$lv" "
299 lvcreate --snapshot -n$lv.bkp $SNAPSIZE $vg/$lv
300 mkdir -p $SNAPDIR/$lv
301 mount -oro /dev/$vg/$lv.bkp $SNAPDIR/$lv" || return $?
304 hostpath $SNAPDIR/$lv
310 ## Remove the snapshot. Sometimes LVM doesn't notice that the snapshot is
311 ## no longer in open immdiately, so try several times. Sometimes, more
312 ## mysteriously, something is keeping the filesystem from being unmounted,
313 ## so try that several times and report on things keeping the filesystem
315 hostrun "unsnap-lvm $vg/$lv" "
317 echo \";;; BEGIN fuser -mv $SNAPDIR/$lv\"
318 fuser -mv $SNAPDIR/$lv | sed 's/^/;;; /'
319 echo \";;; END fuser -mv $SNAPDIR/$lv\"
320 echo \";;; BEGIN lsof $SNAPDIR/$lv\"
321 lsof $SNAPDIR/$lv | sed 's/^/;;; /'
322 echo \";;; END lsof $SNAPDIR/$lv\"
323 if umount $SNAPDIR/$lv; then break; fi
328 if lvremove -f $vg/$lv.bkp; then rc=0; break; fi
331 exit $rc" || return $?
334 ## Complicated snapshot using LVM, where the volume group and filesystem are
335 ## owned by different machines, so they need to be synchronized during the
339 lvhost=$1 vg=$2 lv=$3 fshost=$4 fsdir=$5
341 ## Engage in the rfreezefs protocol with the filesystem host. This
342 ## involves some hairy plumbing. We want to get exit statuses out of both
345 ssh $fshost rfreezefs $fsdir | {
348 ## Read the codebook from the remote end.
354 TOKEN) eval tok_$2=$3 ;;
355 READY) ready=t; break ;;
357 echo >&2 "$quis: unexpected keyword $1 (rfreezefs to $rhost)"
364 echo >&2 "$quis: unexpected eof (rfreezefs to $rhost)"
369 ## Connect to the filesystem host's TCP port and get it to freeze its
371 exec 3<>/dev/tcp/$fshost/$port
377 echo >&2 "$quis: unexpected token $tok (rfreezefs $fsdir on $fshost)"
382 ## Get the volume host to create the snapshot.
384 _hostrun >&2 3>&- $userat$lvhost \
385 "lvcreate --snapshot -n$lv.bkp $SNAPSIZE $vg/$lv"
389 ## The filesystem can thaw now.
395 _hostrun >&2 3>&- $userat$lvhost "lvremove -f $vg/$lv.bkp" || :
396 echo >&2 "$quis: unexpected token $tok (rfreezefs $fsdir on $fshost)"
405 ## Sift through the wreckage to find out what happened.
406 rc_rfreezefs=${PIPESTATUS[0]} rc_snapshot=${PIPESTATUS[1]}
408 case $rc_rfreezefs:$rc_snapshot in
412 echo >&2 "$quis: EMERGENCY failed to thaw $fsdir on $fshost!"
416 echo >&2 "$quis: failed to snapshot $vg/$lv ($fsdir on $fshost)"
421 ## Mount the snapshot on the volume host.
422 _hostrun >&2 $userat$lvhost "
423 mkdir -p $SNAPDIR/$lv
424 mount -oro /dev/$vg/$lv.bkp $SNAPDIR/$lv"
428 rhost=$1 vg=$2 lv=$3 rfs=$4
431 run "snap-rfreezefs $host:$vg/$lv $rhost:$rfs" \
432 do_rfreezefs $host $vg $lv $rhost $rfs || return $?
433 hostpath $SNAPDIR/$lv
436 unsnap_rfreezefs () {
438 ## Unshapping is the same as for plain LVM.
439 rhost=$1 vg=$2 lv=$3 rfs=$4
443 ###--------------------------------------------------------------------------
444 ### Expiry computations.
447 ## Read dates on stdin; write to stdout `EXPIRE date' for dates which
448 ## should be expired and `RETAIN date' for dates which should be retained.
450 ## Get the current date and convert it into useful forms.
451 now=$(date +%Y-%m-%d)
453 now_jdn=$(julian $now) now_year=$year now_month=$month now_day=$day
456 ## Work through each date in the input.
460 ## Convert the date into a useful form.
464 ## Work through the policy list.
465 if [ $jdn -le $now_jdn ]; then
466 while read ival age; do
468 ## Decide whether the policy entry applies to this date.
475 if [ $year -eq $now_year ] ||
476 ([ $year -eq $(( $now_year - 1 )) ] &&
477 [ $month -ge $now_month ])
481 if ([ $month -eq $now_month ] && [ $year -eq $now_year ]) ||
482 ((([ $month -eq $(( $now_month - 1 )) ] &&
483 [ $year -eq $now_year ]) ||
484 ([ $month -eq 12 ] && [ $now_month -eq 1 ] &&
485 [ $year -eq $(( $now_year - 1 )) ])) &&
486 [ $day -ge $now_day ])
490 if [ $jdn -ge $(( $now_jdn - 7 )) ]; then apply=t; fi
493 echo >&2 "$quis: unknown age symbol \`$age'"
497 case $apply in nil) continue ;; esac
499 ## Find the interval marker for this date.
505 ydn=$(julian $year-01-01)
506 wk=$(( ($jdn - $ydn)/7 + 1 ))
516 echo >&2 "$quis: unknown interval symbol \`$ival'"
521 ## See if we've alredy retained something in this interval.
524 *) keep=t kept=$kept$marker: ;;
533 t) echo RETAIN $date ;;
534 *) echo EXPIRE $date ;;
540 ###--------------------------------------------------------------------------
541 ### Actually taking backups of filesystems.
553 md5 | sha1 | sha224 | sha256 | sha384 | sha512)
554 set -- $(${HASH}sum <"$file")
558 set -- $(openssl dgst -$HASH <"$file")
565 _hostrun $userat$host "
569 echo \"*** $host $fs $date\"; echo
570 rsync -rx --filter='dir-merge .rsync-backup' ./ |
571 fshash -c$fshashdir/$fs.bkp -a -H$HASH -frsync
576 { echo "*** $host $fs $date"; echo
577 fshash -c$STOREDIR/fshash.cache -H$HASH new/
585 case $i in *[!-0-9]*) continue ;; esac
586 case $seen in *:"$i":*) continue ;; esac
591 while read op date; do
594 echo >&2 " --- keep $date"
597 echo >&2 " --- delete $date"
604 $verbose -n " expire $date..."
606 delete_index $host $fs $date
618 backup_precommit_hook () {
619 host=$1 fs=$2 date=$3
620 ## Compatibility: You can override this hook in the configuration file for
621 ## special effects; but it's better to use `addhook precommit'.
625 addhook precommit backup_precommit_hook
627 backup_commit_hook () {
628 host=$1 fs=$2 date=$3
629 ## Compatibility: You can override this hook in the configuration file for
630 ## special effects; but it's better to use `addhook commit'.
634 addhook commit backup_commit_hook
637 date=$1 fs=$2 fsarg=$3
638 ## Back up FS on the current host.
644 ## Run a hook beforehand.
645 set +e; runhook setup $host $fs $date; rc=$?; set -e
648 99) log "BACKUP of $host:$fs SKIPPED by hook"; return 0 ;;
649 *) log "BACKUP of $host:$fs FAILED (hook returns $?)"; return $? ;;
652 ## Report the start of this attempt.
653 log "START BACKUP of $host:$fs"
655 ## Maybe we need to retry the backup.
658 ## Rig checksum variables to mismatch unless they're set later.
659 hrfs=REMOTE hlfs=LOCAL
661 ## Create and mount the remote snapshot.
664 maybe snap_$snap $fs $fsarg
668 snapmnt=$(snap_$snap $snapargs $fs $fsarg) || return $?
671 $verbose " create snapshot"
673 ## If we had a fshash-mismatch, then clear out the potentially stale
674 ## entries, both locally and remotely.
678 $verbose " prune cache"
679 run -stdin "local prune fshash" \
680 fshash -u -c$STOREDIR/fshash.cache -H$HASH new/ <$fshash_diff
681 run -stdin "@$host: prune fshash" \
682 _hostrun $userat$host <$fshash_diff \
683 "fshash -u -c$fshashdir/$fs.bkp -H$HASH ${snapmnt#*:}"
687 ## Build the list of hardlink sources.
689 for i in $host $like; do
690 d=$STOREDIR/$i/$fs/last/
691 if [ -d $d ]; then linkdests="$linkdests --link-dest=$d"; fi
694 ## Copy files from the remote snapshot.
697 t) $verbose " running rsync" ;;
698 nil) $verbose -n " running rsync..." ;;
701 run "RSYNC of $host:$fs (snapshot on $snapmnt)" do_rsync \
707 case $dryrun in nil) $verbose " done" ;; esac
709 ## Collect a map of the snapshot for verification purposes.
712 t) $verbose " remote fshash" ;;
713 nil) $verbose -n " remote fshash..." ;;
715 run "@$host: fshash $fs" remote_fshash
720 hrfs=$(hash_file "new.fshash")
721 log "remote fshash $HASH checksum: $hrfs"
729 ## Remove the snapshot.
730 maybe unsnap_$snap $snapargs $fs $fsarg
731 $verbose " remove snapshot"
733 ## If we failed to copy, then give up.
734 case $rc_rsync:$rc_fshash in
736 0:*) return $rc_fshash ;;
737 *) return $rc_rsync ;;
740 ## Get a matching map of the files received.
741 maybe mkdir -m750 -p $STOREDIR/tmp/
742 localmap=$STOREDIR/tmp/fshash.$host.$fs.$date
744 t) $verbose " local fshash" ;;
745 nil) $verbose -n " local fshash..." ;;
747 run "local fshash $host:$fs" local_fshash || return $?
750 hlfs=$(hash_file "$localmap")
751 log "local fshash $HASH checksum: $hlfs"
759 ## Compare the two maps.
761 fshash_diff=$STOREDIR/tmp/fshash-diff.$host.$fs.$date
762 run "compare fshash maps for $host:$fs" \
763 run_diff $fshash_diff new.fshash $localmap
771 if [ $attempt -ge $retry ]; then return $rc; fi
772 $verbose " fshash mismatch; retrying"
773 attempt=$(( $attempt + 1 ))
781 ## Double-check the checksums.
782 if [ $hrfs != $hlfs ]; then
784 $0: INTERNAL ERROR: fshash $HASH checksum mismatch -- aborting
785 remote fshash checksum = $hrfs
786 local fshash checksum = $hlfs
792 maybe rm -f $localmap
793 case $fshash_diff in nil) ;; *) maybe rm -f $fshash_diff ;; esac
794 $verbose " fshash match"
796 ## Commit this backup.
799 runhook precommit $host $fs $date
801 mv new.fshash $date.fshash
802 insert_index $host $fs $date $VOLUME
803 runhook commit $host $fs $date
805 ln -s $date hack/last
812 ## Expire old backups.
813 case "${expire_policy+t},${default_policy+t}" in
814 ,t) expire_policy=$default_policy ;;
816 case "${expire_policy+t},$dryrun" in
817 t,nil) run "expiry for $host:$fs" expire_backups ;;
818 t,t) expire_backups ;;
824 t) log "END BACKUP of $host:$fs" ;;
825 nil) log "SUCCESSFUL BACKUP of $host:$fs" ;;
830 fs=$1 date=$2 cmd=$3; shift 3
831 ## try_backup FS DATE COMMAND ARGS ...
833 ## Run COMMAND ARGS to back up filesystem FS on the current host,
834 ## maintaining a log, and checking whether it worked. The caller has
835 ## usually worked out the DATE in order to set up the filesystem, and we
836 ## need it to name the log file properly.
838 ## Find a name for the log file. In unusual circumstances, we may have
839 ## deleted old logs from today, so just checking for an unused sequence
840 ## number is insufficient. Instead, check all of the logfiles for today,
841 ## and use a sequence number that's larger than any of them.
848 for i in "$logdir/$host/$fs.$date#"*; do
850 case "$tail" in [!1-9]* | *[!0-9]*) continue ;; esac
851 if [ -f "$i" -a $tail -ge $seq ]; then seq=$(( tail + 1 )); fi
853 log="$logdir/$host/$fs.$date#$seq"
857 ## Run the backup command.
858 case $dryrun in nil) mkdir -p $logdir/$host ;; esac
859 if ! "$cmd" "$@" 9>$log 1>&9; then
861 echo >&2 "$quis: backup of $host:$fs FAILED!"
865 ## Clear away any old logfiles.
866 remove_old_logfiles "$logdir/$host/$fs"
870 ## backup FS[:ARG] ...
872 ## Back up the filesystems on the currently selected host using the
873 ## currently selected snapshot type.
875 ## Make sure that there's a store volume. We must do this here rather than
876 ## in the main body of the script, since the configuration file needs a
877 ## chance to override STOREDIR.
878 if ! [ -r $STOREDIR/.rsync-backup-store ]; then
879 echo >&2 "$quis: no backup volume mounted"
883 ## Read the volume name if we don't have one already. Again, this allows
884 ## the configuration file to provide a volume name.
885 case "${VOLUME+t}${VOLUME-nil}" in
886 nil) VOLUME=$(cat $METADIR/volume) ;;
889 ## Back up each requested file system in turn.
892 ## Parse the argument.
894 *:*) fsarg=${fs#*:} fs=${fs%%:*} ;;
897 $verbose " filesystem $fs"
899 ## Move to the store directory and set up somewhere to put this backup.
903 if [ ! -d $host ]; then
905 chown root:root $host
907 if [ ! -d $host/$fs ]; then
908 mkdir -m750 $host/$fs
909 chown root:backup $host/$fs
915 ## Find out if we've already copied this filesystem today.
916 date=$(date +%Y-%m-%d)
917 if [ $dryrun = nil ] && [ -d $date ]; then
918 $verbose " already dumped"
922 ## Do the backup of this filesystem.
923 run_backup_cmd $fs $date do_backup $date $fs $fsarg
927 ###--------------------------------------------------------------------------
928 ### Configuration functions.
933 done_first_host_p=nil
938 case $done_first_host_p in
939 nil) runhook start; done_first_host_p=t ;;
941 case "${expire_policy+t},${default_policy+t}" in
942 t,) default_policy=$expire_policy ;;
945 $verbose "host $host"
948 snaptype () { snap=$1; shift; snapargs="$*"; retry=1; }
949 rsyncargs () { rsyncargs="$*"; }
950 like () { like="$*"; }
951 retry () { retry="$*"; }
952 user () { userat="$*@"; }
955 case $clear_policy in t) unset expire_policy; clear_policy=nil ;; esac
956 expire_policy="${expire_policy+$expire_policy
960 ###--------------------------------------------------------------------------
961 ### Read the configuration and we're done.
964 echo "usage: $quis [-nv] [-c CONF]"
968 echo "$quis version $VERSION"
971 whine () { echo >&8 "$@"; }
973 while getopts "hVvc:n" opt; do
976 V) version; config; exit 0 ;;
983 shift $((OPTIND - 1))
984 case $# in 0) ;; *) usage >&2; exit 1 ;; esac
991 0) $verbose "All backups successful" ;;
992 *) $verbose "Backups FAILED" ;;
995 ###----- That's all, folks --------------------------------------------------